﻿/**

Livewire Flash - Core code for running the Livewire algorithm
Copyright (C) 2011  Jeffrey Bush  jeff@coderforlife.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

**/

// This is a Flash-only class to help with memory usage

package Livewire.Pools
{
	public final class IntVectors
	{
		private var _avail:Vector.<Vector.<int>>;
		private var _count:uint = 0;
		
		public final function IntVectors(capacity:uint)
		{
			this._avail = new Vector.<Vector.<int>>(capacity, true);
		}
		
		public final function Get(len:uint, fixed:Boolean):Vector.<int>
		{
			if (this._count == 0)
				return new Vector.<int>(len, fixed);
			var v:Vector.<int> = this._avail[--this._count];
			v.fixed = false;
			v.length = len;
			v.fixed = fixed;
			return v;
		}
		
		public final function Return(v:Vector.<int>):void
		{
			if (this._count == this._avail.length)
			{
				this._avail.fixed = false;
				this._avail.length = this._count * 2;
				this._avail.fixed = true;
			}
			this._avail[this._count++] = v;
		}
	}
}
